#include "mainwindow.h"
#include "ui_mainwindow.h"
//#include "ImageTranscode.h"

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);
    this->setWindowTitle("网络监控");
    this->setWindowIcon(QIcon("./source/main.ico"));
    //视频显示初始化
    videoScene=new QGraphicsScene();
    framWidth=ui->graphicsView->width();
    framHeight=ui->graphicsView->height();
    //临时文件
//    QByteArray a("a1234567");
//    QByteArray b;
//    b.resize(4);
//    for(int i=0;i<4;i++)
//        b[i]=a[i];
//    qDebug()<<a.data()<<b.data();

    capframe=(unsigned char *)malloc(640* 480* 3 * sizeof(char));
    //memset(capframe,0,640* 480* 3 * sizeof(char));
    //captureImage=new QImage(capframe,640,480,QImage::Format_RGB888);
    captureImage=new QImage();
    //captureImage->load("./source/test.jpg");
    //videoScene->addPixmap(QPixmap::fromImage(*captureImage));
    ui->graphicsView->setScene(videoScene);
    ui->graphicsView->show();

    //UDP初始化
    portSer=5555;
    portCli=8001;
    hostaddrSer=new QHostAddress("219.216.88.107");//服务器IP
    hostaddrCli=new QHostAddress("219.216.88.118");//客户机IP
    //创建 QUdpSocket 对象
    udpSocket=new QUdpSocket(this);
    bool conn=udpSocket->bind(*hostaddrSer,portSer);  //socket绑定服务器端IP 端口
    //QHostAddress::LocalHost
    if(!conn){
        QMessageBox box;
        box.setText("链接错误");
        box.exec();
    }else{
        //把udpSocket的信号关联到槽
        connect(udpSocket,SIGNAL(readyRead()),this,SLOT(receiveData()));
        connect(ui->UDPEdit,SIGNAL(returnPressed()),this,SLOT(sendData()));
    }

    timer = new QTimer(this);
    //connect(timer,SIGNAL(timeout()),this,SLOT(disimage()));
    //timer->start(30);
}

MainWindow::~MainWindow()
{
    free(capframe);
    delete ui;
}
void MainWindow::sendData()
{
    QString text=ui->UDPEdit->text();
    if(text.length()==0)
        QMessageBox::information(this,"Error","please input text");
    int len=0;
    text=text+'\n';
    len=udpSocket->writeDatagram(text.toLatin1(),text.length(),*hostaddrCli,portCli);
    if(len==0)
        QMessageBox::information(this,"Error","send failed");

}
/*void MainWindow::receiveData()
{
    while(udpSocket->hasPendingDatagrams()){    //是否读到数据
        for(int i=0;i<1800;i++)
        {
            qDebug()<<"rec %d"<<i;
            udpSocket->readDatagram((char *)(&udprecdata),BLOCKSIZE+4,hostaddrCli,&portCli);
            count+=udprecdata.flag;
            memcpy(capframe+i*BLOCKSIZE,udprecdata.buf,BLOCKSIZE);
            if(i==1799)
            {
                this->disimage();
            }
//           // if(udprecdata.flag==2)
//            {
//                if(count==1801)
//                {
//                    this->disimage();
//                    count=0;
//                    i=0;
//                    qDebug()<<"dis";
//                }
//                else if(count>1801)
//                {
//                    count=0;
//                    i=0;
//                }
//                //qDebug()<<"get final";
//            }


        }
//        QByteArray data;
//        //udpSocket->pendingDatagramSize 获取报文长度
//        //data.resize 给 data 数组设置长度
//        data.resize(udpSocket->pendingDatagramSize());
//        //读入数据

//        udpSocket->readDatagram(data.data(),data.size(),hostaddrCli,&portCli);
//        //显示数据内容
//        QString str=data.data();
//        ui->UDPEdit->insertPlainText(str);
//        sendData();
//        captureImage->load("./source/test.jpg");
//        QPixmap frame=QPixmap::fromImage(captureImage->scaled(framWidth-5,framHeight-5));
//        videoScene->addPixmap(frame);
//        this->videoScene->update();
    }
}*/
void MainWindow::receiveData()
{
     while(udpSocket->hasPendingDatagrams()){    //是否读到数据
        static int num=0;
         QByteArray data;
         //udpSocket->pendingDatagramSize 获取报文长度
         //data.resize 给 data 数组设置长度
         data.resize(udpSocket->pendingDatagramSize());
         //读入数据
         udpSocket->readDatagram(data.data(),data.size(),hostaddrCli,&portCli);
         //显示数据内容
         QByteArray flag;
         flag.resize(1);
         for(int i=0;i<1;i++)
             flag[i]=data[i+BLOCKSIZE];
         data.remove(BLOCKSIZE,1);
         //qDebug()<<"flag="<<flag.data();
         char *frameflag=flag.data();
//         QString str=data.data();
//         ui->UDPEdit->insertPlainText(str);
//         qDebug()<<"udp str size="<<str.size();
         //qDebug()<<"udp data size="<<data.size();
         //if(flag.data()=='a')
         tempdata.append(data);
         if(*frameflag=='a'+num)
            num++;
         else
         {
             int framenum=0;
             for(char k='a';k<='x';k++)
             {
                 if(k==*frameflag)
                 {
                     QByteArray clearblock;
                     clearblock.resize(BLOCKSIZE);
                     num=framenum+1;
                     tempdata.clear();
                     for(int p=0;p<framenum;p++)
                         tempdata.append(clearblock);
                     //tempdata.remove(BLOCKSIZE*num,tempdata.size()-BLOCKSIZE*num);
                     qDebug()<<"frame err @block_"<<k<<"_"<<framenum;
                     break;
                 }
                    framenum++;
              }
         }
         if(num==24)
         {
             if(*frameflag=='x')
             {
                 this->disimage();
                 num=0;
                 tempdata.clear();
             }
             else
             {
                qDebug()<<"frame err *frameflag="<<*frameflag;
//                 int framenum=0;
//                 for(char k='a';k<='x';k++)
//                 {
//                     if(k==*frameflag)
//                     {
//                         QByteArray clearblock;
//                         clearblock.resize(BLOCKSIZE);
//                         num=framenum+1;
//                         tempdata.clear();
//                         for(int p=0;p<framenum;p++)
//                             tempdata.append(clearblock);
//                         //tempdata.remove(BLOCKSIZE*num,tempdata.size()-BLOCKSIZE*num);
//                         qDebug()<<"frame err @block_"<<k<<"_"<<framenum;
//                     }
//                     framenum++;
//                 }
             }
         }


     }
}

/*void MainWindow::disimage()
{
    QByteArray aa ;
    QPixmap pix;
     BITMAPFILEHEADER bf;
     BITMAPINFOHEADER bi;
     //Set BITMAPINFOHEADER
     bi.biSize = 40;
     bi.biWidth = 640;
     bi.biHeight = 480;
     bi.biPlanes = 1;
     bi.biBitCount = 24;
     bi.biCompression = 0;
     bi.biSizeImage = 640*480*3;
     bi.biXPelsPerMeter = 0;
     bi.biYPelsPerMeter = 0;
     bi.biClrUsed = 0;
     bi.biClrImportant = 0;

     //Set BITMAPFILEHEADER
     bf.bfType = 0x4d42;
     bf.bfSize = 54 + bi.biSizeImage;
     //bf.bfReserved = 0;
     bf.bfOffBits = 54;

     aa.append((char *)&bf,14);
     aa.append((char *)&bi,40);
     //aa.append((char *)capframe,640*480*3);
     aa.append(tempdata);
     pix.loadFromData(aa);
     if(!pix.isNull())
     {
        QMatrix leftmatrix;
        leftmatrix.rotate(180);
        pix.transformed(leftmatrix,Qt::SmoothTransformation);
        pix.scaled(framWidth-5,framHeight-5);
     }
     videoScene->addPixmap(pix);
     this->videoScene->update();
    // ui->label->setPixmap(pix);

//    if(!(captureImage->loadFromData((const unsigned char *)capframe,640* 480 * 3 * sizeof(char))))
//            qDebug()<<"err load";
    //QPixmap frame=captureImage->scaled(framWidth-5,framHeight-5);
    //captureImage->load("./source/test.jpg");
//    videoScene->addPixmap(QPixmap::fromImage(*captureImage,Qt::AutoColor));
//    this->videoScene->update();
    //ui->label->setPixmap(QPixmap::fromImage(*captureImage));

    qDebug()<<"dis";
}*/
typedef  struct  tagBITMAPFILEHEADER
{
unsigned short int  bfType;       //位图文件的类型，必须为BM
unsigned long       bfSize;       //文件大小，以字节为单位
unsigned short int  bfReserverd1; //位图文件保留字，必须为0
unsigned short int  bfReserverd2; //位图文件保留字，必须为0
unsigned long       bfOffBits;  //位图文件头到数据的偏移量，以字节为单位
}BITMAPFILEHEADER;
typedef  struct  tagBITMAPINFOHEADER
{
long biSize;                        //该结构大小，字节为单位
long  biWidth;                     //图形宽度以象素为单位
long  biHeight;                     //图形高度以象素为单位
short int  biPlanes;               //目标设备的级别，必须为1
short int  biBitCount;             //颜色深度，每个象素所需要的位数
short int  biCompression;        //位图的压缩类型
long  biSizeImage;              //位图的大小，以字节为单位
long  biXPelsPerMeter;       //位图水平分辨率，每米像素数
long  biYPelsPerMeter;       //位图垂直分辨率，每米像素数
long  biClrUsed;            //位图实际使用的颜色表中的颜色数
long  biClrImportant;       //位图显示过程中重要的颜色数
}BITMAPINFOHEADER;
void MainWindow::disimage()
{
    QByteArray aa ;
     BITMAPFILEHEADER bf;
     BITMAPINFOHEADER bi;
     //Set BITMAPINFOHEADER
     bi.biSize = 40;
     bi.biWidth = 640;
     bi.biHeight = 480;
     bi.biPlanes = 1;
     bi.biBitCount = 24;
     bi.biCompression = 0;
     bi.biSizeImage = 640*480*3;
     bi.biXPelsPerMeter = 0;
     bi.biYPelsPerMeter = 0;
     bi.biClrUsed = 0;
     bi.biClrImportant = 0;

     //Set BITMAPFILEHEADER
     bf.bfType = 0x4d42;
     bf.bfSize = 54 + bi.biSizeImage;
     //bf.bfReserved = 0;
     bf.bfOffBits = 54;

     aa.append((char *)&bf,14);
     aa.append((char *)&bi,40);
     //aa.append((char *)capframe,640*480*3);
     aa.append(tempdata);
     captureImage->loadFromData(aa);
     QImage temp;
     if(!captureImage->isNull())
     {
//       QMatrix leftmatrix;
//        leftmatrix.rotate(180.0);
//        captureImage->transformed(leftmatrix,Qt::SmoothTransformation);
        temp= captureImage->mirrored(false,true);
        *captureImage=temp.scaled(framWidth-5,framHeight-5);
     }
     videoScene->addPixmap(QPixmap::fromImage(*captureImage));
     this->videoScene->update();
    // ui->label->setPixmap(pix);

//    if(!(captureImage->loadFromData((const unsigned char *)capframe,640* 480 * 3 * sizeof(char))))
//            qDebug()<<"err load";
    //QPixmap frame=captureImage->scaled(framWidth-5,framHeight-5);
    //captureImage->load("./source/test.jpg");
//    videoScene->addPixmap(QPixmap::fromImage(*captureImage,Qt::AutoColor));
//    this->videoScene->update();
    //ui->label->setPixmap(QPixmap::fromImage(*captureImage));

}
